using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp2
{
    class Program
    {
     
        static void Main(string[] args)
        {

            string[] s = Console.ReadLine().Split();
            int n = int.Parse(s[0]);//kolike je puta pronasao plazmu
            int q = int.Parse(s[1]);//broj pitanja
            long[] niz = new long[600000];
            long[,] matrica = new long[n,2];
            for (int i=0;i<n;i++) 
            {
                s = Console.ReadLine().Split();
                matrica[i, 0] = long.Parse(s[0]);
                matrica[i, 1] = long.Parse(s[1]);
            }
            long plazma = 0;
            long nekibrojac = 0;
            long poslednjirazlicit = 0;
            for (int i = 0; i <300000; i++) 
            {
                if (nekibrojac < n) 
                {
                    if (matrica[nekibrojac, 0]-1 == i)
                    {
                        plazma += matrica[nekibrojac, 1];
                        nekibrojac++;
                    }
                }
                if (plazma != 0)
                {
                    poslednjirazlicit++;
                    niz[i]=poslednjirazlicit;
                    plazma--;
                    
                }
            }
            for (int i=0;i<q;i++ ) 
            {
                
                long danprestajanja = long.Parse(Console.ReadLine());
                if (danprestajanja < 300000)
                {
                    Console.WriteLine(niz[danprestajanja - 1]);
                }
                else 
                {
                    Console.WriteLine(poslednjirazlicit);
                }
            }
            Console.ReadLine();
        }
    }
}